# Ipopt::AlgorithmStrategyObject Class Reference

This is the base class for all algorithm strategy objects. More...

`#include <IpAlgStrategy.hpp>`

Inheritance diagram for Ipopt::AlgorithmStrategyObject:
[legend]

List of all members.

## Public Member Functions
bool | Initialize (const Journalist &jnlst, IpoptNLP &ip_nlp, IpoptData &ip_data, IpoptCalculatedQuantities &ip_cq, const OptionsList &options, const std::string &prefix)
| This method is called every time the algorithm starts again - it is used to reset any internal state.
bool | ReducedInitialize (const Journalist &jnlst, const OptionsList &options, const std::string &prefix)
| Reduced version of the Initialize method, which does not require special Ipopt information.
Constructors/Destructors
| AlgorithmStrategyObject ()
| Default Constructor.
virtual | ~AlgorithmStrategyObject ()
| Default Destructor.
## Protected Member Functions
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)=0
| Implementation of the initialization method that has to be overloaded by for each derived class.
Accessor methods for the problem defining objects.
Those should be used by the derived classes.
const Journalist & | Jnlst () const
IpoptNLP & | IpNLP () const
IpoptData & | IpData () const
IpoptCalculatedQuantities & | IpCq () const
bool | HaveIpData () const
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| AlgorithmStrategyObject (const AlgorithmStrategyObject &)
| Default Constructor.
void | operator= (const AlgorithmStrategyObject &)
| Overloaded Equals Operator.
## Private Attributes
bool | initialize_called_
| flag indicating if Initialize method has been called (for debugging)
Pointers to objects defining a particular optimization
problem
SmartPtr< const Journalist > | jnlst_
SmartPtr< IpoptNLP > | ip_nlp_
SmartPtr< IpoptData > | ip_data_
SmartPtr < IpoptCalculatedQuantities > | ip_cq_

## Detailed Description

This is the base class for all algorithm strategy objects.

The AlgorithmStrategyObject base class implements a common interface for all algorithm strategy objects. A strategy object is a component of the algorithm for which different alternatives or implementations exists. It allows to compose the algorithm before execution for a particular configuration, without the need to call alternatives based on enums. For example, the LineSearch object is a strategy object, since different line search options might be used for different runs.

This interface is used for things that are done to all strategy objects, like initialization and setting options.

Definition at line 35 of file IpAlgStrategy.hpp.

## Constructor & Destructor Documentation

Ipopt::AlgorithmStrategyObject::AlgorithmStrategyObject | ( |  | ) | `[inline]`

Default Constructor.

Definition at line 41 of file IpAlgStrategy.hpp.

virtual Ipopt::AlgorithmStrategyObject::~AlgorithmStrategyObject | ( |  | ) | `[inline, virtual]`

Default Destructor.

Definition at line 47 of file IpAlgStrategy.hpp.

Ipopt::AlgorithmStrategyObject::AlgorithmStrategyObject | ( | const AlgorithmStrategyObject & |  | ) | `[private]`

Default Constructor.

Copy Constructor

## Member Function Documentation

bool Ipopt::AlgorithmStrategyObject::Initialize | ( | const Journalist & | jnlst,
|  | IpoptNLP & | ip_nlp,
|  | IpoptData & | ip_data,
|  | IpoptCalculatedQuantities & | ip_cq,
|  | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[inline]`

This method is called every time the algorithm starts again - it is used to reset any internal state.

The pointers to the Journalist, as well as to the IpoptNLP, IpoptData, and IpoptCalculatedQuantities objects should be stored in the instanciation of this base class. This method is also used to get all required user options from the OptionsList. Here, if prefix is given, each tag (identifying the options) is first looked for with the prefix in front, and if not found, without the prefix. Note: you should not cue off of the iteration count to indicate the "start" of an algorithm!

Do not overload this method, since it does some general initialization that is common for all strategy objects. Overload the protected InitializeImpl method instead.

Definition at line 66 of file IpAlgStrategy.hpp.

bool Ipopt::AlgorithmStrategyObject::ReducedInitialize | ( | const Journalist & | jnlst,
|  | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[inline]`

Reduced version of the Initialize method, which does not require special Ipopt information.

This is useful for algorithm objects that could be used outside Ipopt, such as linear solvers.

Definition at line 92 of file IpAlgStrategy.hpp.

virtual bool Ipopt::AlgorithmStrategyObject::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[protected, pure virtual]`

Implementation of the initialization method that has to be overloaded by for each derived class.

Implemented in Ipopt::SensAlgorithm, Ipopt::IndexPCalculator, Ipopt::MetadataMeasurement, Ipopt::PCalculator, Ipopt::ReducedHessianCalculator, Ipopt::SchurDriver, Ipopt::SimpleBacksolver, Ipopt::StdStepCalculator, Ipopt::SensitivityStepCalculator, Ipopt::InexactDoglegNormalStep, Ipopt::InexactLSAcceptor, Ipopt::InexactNewtonNormalStep, Ipopt::InexactNormalStepCalculator, Ipopt::InexactNormalTerminationTester, Ipopt::InexactPDSolver, Ipopt::InexactPDTerminationTester, Ipopt::InexactSearchDirCalculator, Ipopt::InexactTSymScalingMethod, Ipopt::IterativePardisoSolverInterface, Ipopt::IterativeSolverTerminationTester, Ipopt::AdaptiveMuUpdate, Ipopt::AugRestoSystemSolver, Ipopt::AugSystemSolver, Ipopt::BacktrackingLineSearch, Ipopt::BacktrackingLSAcceptor, Ipopt::ConvergenceCheck, Ipopt::DefaultIterateInitializer, Ipopt::EqMultiplierCalculator, Ipopt::ExactHessianUpdater, Ipopt::FilterLSAcceptor, Ipopt::GenAugSystemSolver, Ipopt::HessianUpdater, Ipopt::IpoptAlgorithm, Ipopt::IterateInitializer, Ipopt::IterationOutput, Ipopt::LeastSquareMultipliers, Ipopt::LimMemQuasiNewtonUpdater, Ipopt::LoqoMuOracle, Ipopt::LowRankAugSystemSolver, Ipopt::LowRankSSAugSystemSolver, Ipopt::MonotoneMuUpdate, Ipopt::MuOracle, Ipopt::MuUpdate, Ipopt::OptimalityErrorConvergenceCheck, Ipopt::OrigIterationOutput, Ipopt::PDFullSpaceSolver, Ipopt::PDPerturbationHandler, Ipopt::PDSearchDirCalculator, Ipopt::PDSystemSolver, Ipopt::PenaltyLSAcceptor, Ipopt::ProbingMuOracle, Ipopt::QualityFunctionMuOracle, Ipopt::RestoConvergenceCheck, Ipopt::RestoFilterConvergenceCheck, Ipopt::RestoIterateInitializer, Ipopt::RestoIterationOutput, Ipopt::MinC_1NrmRestorationPhase, Ipopt::RestoPenaltyConvergenceCheck, Ipopt::RestorationPhase, Ipopt::RestoRestorationPhase, Ipopt::SearchDirectionCalculator, Ipopt::StdAugSystemSolver, Ipopt::WarmStartIterateInitializer, Ipopt::GenKKTSolverInterface, Ipopt::IterativeWsmpSolverInterface, Ipopt::Ma27TSolverInterface, Ipopt::Ma28TDependencyDetector, Ipopt::Ma57TSolverInterface, Ipopt::Ma77SolverInterface, Ipopt::Ma86SolverInterface, Ipopt::Ma97SolverInterface, Ipopt::Mc19TSymScalingMethod, Ipopt::MumpsSolverInterface, Ipopt::PardisoSolverInterface, Ipopt::SlackBasedTSymScalingMethod, Ipopt::SparseSymLinearSolverInterface, Ipopt::SymLinearSolver, Ipopt::TDependencyDetector, Ipopt::TSymDependencyDetector, Ipopt::TSymLinearSolver, Ipopt::TSymScalingMethod, Ipopt::WsmpSolverInterface, Ipopt::CGPenaltyLSAcceptor, Ipopt::CGPerturbationHandler, and Ipopt::CGSearchDirCalculator.

const Journalist& Ipopt::AlgorithmStrategyObject::Jnlst | ( |  | ) | const`[inline, protected]`

Definition at line 120 of file IpAlgStrategy.hpp.

IpoptNLP& Ipopt::AlgorithmStrategyObject::IpNLP | ( |  | ) | const`[inline, protected]`

Definition at line 125 of file IpAlgStrategy.hpp.

IpoptData& Ipopt::AlgorithmStrategyObject::IpData | ( |  | ) | const`[inline, protected]`

Definition at line 131 of file IpAlgStrategy.hpp.

IpoptCalculatedQuantities& Ipopt::AlgorithmStrategyObject::IpCq | ( |  | ) | const`[inline, protected]`

Definition at line 137 of file IpAlgStrategy.hpp.

bool Ipopt::AlgorithmStrategyObject::HaveIpData | ( |  | ) | const`[inline, protected]`

Definition at line 143 of file IpAlgStrategy.hpp.

void Ipopt::AlgorithmStrategyObject::operator= | ( | const AlgorithmStrategyObject & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented in Ipopt::InexactDoglegNormalStep, Ipopt::InexactLSAcceptor, Ipopt::InexactNewtonNormalStep, Ipopt::InexactNormalStepCalculator, Ipopt::InexactNormalTerminationTester, Ipopt::InexactPDSolver, Ipopt::InexactPDTerminationTester, Ipopt::InexactSearchDirCalculator, Ipopt::InexactTSymScalingMethod, Ipopt::IterativePardisoSolverInterface, Ipopt::IterativeSolverTerminationTester, Ipopt::AdaptiveMuUpdate, Ipopt::AugRestoSystemSolver, Ipopt::AugSystemSolver, Ipopt::BacktrackingLineSearch, Ipopt::BacktrackingLSAcceptor, Ipopt::ConvergenceCheck, Ipopt::DefaultIterateInitializer, Ipopt::EqMultiplierCalculator, Ipopt::ExactHessianUpdater, Ipopt::FilterLSAcceptor, Ipopt::GenAugSystemSolver, Ipopt::HessianUpdater, Ipopt::IpoptAlgorithm, Ipopt::IterateInitializer, Ipopt::IterationOutput, Ipopt::LeastSquareMultipliers, Ipopt::LimMemQuasiNewtonUpdater, Ipopt::LineSearch, Ipopt::LoqoMuOracle, Ipopt::LowRankAugSystemSolver, Ipopt::LowRankSSAugSystemSolver, Ipopt::MonotoneMuUpdate, Ipopt::MuOracle, Ipopt::MuUpdate, Ipopt::OptimalityErrorConvergenceCheck, Ipopt::OrigIterationOutput, Ipopt::PDFullSpaceSolver, Ipopt::PDPerturbationHandler, Ipopt::PDSearchDirCalculator, Ipopt::PDSystemSolver, Ipopt::PenaltyLSAcceptor, Ipopt::ProbingMuOracle, Ipopt::QualityFunctionMuOracle, Ipopt::RestoConvergenceCheck, Ipopt::RestoFilterConvergenceCheck, Ipopt::RestoIterateInitializer, Ipopt::RestoIterationOutput, Ipopt::MinC_1NrmRestorationPhase, Ipopt::RestoPenaltyConvergenceCheck, Ipopt::RestorationPhase, Ipopt::RestoRestorationPhase, Ipopt::SearchDirectionCalculator, Ipopt::StdAugSystemSolver, Ipopt::WarmStartIterateInitializer, Ipopt::IterativeWsmpSolverInterface, Ipopt::Ma27TSolverInterface, Ipopt::Ma28TDependencyDetector, Ipopt::Ma57TSolverInterface, Ipopt::Mc19TSymScalingMethod, Ipopt::MumpsSolverInterface, Ipopt::PardisoSolverInterface, Ipopt::SlackBasedTSymScalingMethod, Ipopt::TDependencyDetector, Ipopt::TSymDependencyDetector, Ipopt::TSymLinearSolver, Ipopt::TSymScalingMethod, Ipopt::WsmpSolverInterface, Ipopt::CGPenaltyLSAcceptor, Ipopt::CGPerturbationHandler, and Ipopt::CGSearchDirCalculator.

## Member Data Documentation

SmartPtr<const Journalist> Ipopt::AlgorithmStrategyObject::jnlst_`[private]`

Reimplemented in Ipopt::Ma28TDependencyDetector, and Ipopt::TSymDependencyDetector.

Definition at line 172 of file IpAlgStrategy.hpp.

SmartPtr<IpoptNLP> Ipopt::AlgorithmStrategyObject::ip_nlp_`[private]`

Definition at line 173 of file IpAlgStrategy.hpp.

SmartPtr<IpoptData> Ipopt::AlgorithmStrategyObject::ip_data_`[private]`

Definition at line 174 of file IpAlgStrategy.hpp.

SmartPtr<IpoptCalculatedQuantities> Ipopt::AlgorithmStrategyObject::ip_cq_`[private]`

Definition at line 175 of file IpAlgStrategy.hpp.

bool Ipopt::AlgorithmStrategyObject::initialize_called_`[private]`

flag indicating if Initialize method has been called (for debugging)

Definition at line 180 of file IpAlgStrategy.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/IpAlgStrategy.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines